import {Component} from '@angular/core';
import {NavigationType} from '../../models/navigation.type';
import {TabMenuModule} from 'primeng/tabmenu';
import {ActivatedRoute, NavigationEnd, Router} from '@angular/router';

@Component({
  selector: 'app-nav',
  standalone: true,
  templateUrl: './nav.component.html',
  imports: [
    TabMenuModule
  ],
  styleUrl: './nav.component.css',
  host: { ngSkipHydration: 'true' }
})
export class NavComponent {

  weddingId!: string;

  guestId!: string;

  items: Array<NavigationType> = [
    { icon: 'assets/icons/home.svg', label: 'Home', command: () => this.navigateTo() },
    { icon: 'assets/icons/picture.svg', label: 'Gallery', command: () => this.navigateTo('gallery') },
    { icon: 'assets/icons/games.svg', label: 'Games', command: () => this.navigateTo('games') }
  ];

  constructor(private router: Router, private route: ActivatedRoute) {}

  ngOnInit(): void {
    this.weddingId = this.route.firstChild?.snapshot.params['weddingId'];
    this.guestId = this.route.firstChild?.snapshot.params['guestId'];
  }

  private navigateTo(...paths: string[]) {
    this.router.navigate(['/wedding', this.weddingId, this.guestId, ...paths]);
  }
}
