import {inject, Injectable} from '@angular/core';
import {HttpClient} from '@angular/common/http';
import {Observable} from 'rxjs';
import {QuizType} from '../models/quiz.type';
import {QuizStateType} from '../models/quizState.type';
import {QuizScoreType} from '../models/quizScore.type';
import {GuestType} from '../models/guests.type';


@Injectable({
  providedIn: 'root'
})
export class GuestsService {

  constructor(private http:HttpClient) { }

  getGuestsByWeddingId(weddingId: string,guestId:string): Observable<[GuestType]> {
    return this.http.get<[GuestType]>(`api/wedding/${weddingId}/${guestId}/guests`);
  }

  sendGuestToEditByWeddingId(weddingId: string,guestId:string,guest:GuestType): Observable<any> {

    const body= { ...guest };

    return this.http.patch(`api/wedding/${weddingId}/${guestId}/guests`, body);
  }

  sendGuestToCreateByWeddingId(weddingId: string,guestId:string,guest:GuestType): Observable<any> {

    const body= { ...guest };

    return this.http.post(`api/wedding/${weddingId}/${guestId}/guests`, body);
  }

  sendGuestToDeleteByWeddingId(weddingId: string,guestId:string,guest:GuestType): Observable<any> {

    const body = { ...guest };

    return this.http.delete(`api/wedding/${weddingId}/${guestId}/guests`, {body});
  }

}
