import {inject, Injectable} from '@angular/core';
import {HttpClient} from '@angular/common/http';
import {Observable} from 'rxjs';
import {QuizType} from '../models/quiz.type';
import {QuizStateType} from '../models/quizState.type';
import {QuizScoreType} from '../models/quizScore.type';


@Injectable({
  providedIn: 'root'
})
export class QuizService {

  constructor(private http:HttpClient) { }

  getQuizByWeddingId(weddingId: string,guestId:string): Observable<QuizType> {
    return this.http.get<QuizType>(`api/wedding/${weddingId}/${guestId}/games/quiz`);
  }

  sendPointsByGuestId(weddingId: string,guestId:string,score:number): Observable<any> {

    const body= { score };

    return this.http.patch(`api/wedding/${weddingId}/${guestId}/games/quiz`, body);
  }

  getQuizStateByWeddingId(weddingId: string,guestId:string): Observable<QuizStateType> {
    return this.http.get<QuizStateType>(`api/wedding/${weddingId}/${guestId}/quiz/state`);
  }

  getQuizScoreByWeddingId(weddingId: string,guestId:string): Observable<QuizScoreType> {
    return this.http.get<QuizScoreType>(`api/wedding/${weddingId}/${guestId}/quiz/score`);
  }
}
